2016-04-03 17:45:16 +02:00
#!/bin/bash
set -e
2016-10-10 13:00:20 +02:00
if [ " $TRAVIS_CI " = = "private" ] ; then
exit 0
fi
2016-04-03 17:45:16 +02:00
if [ " $# " != "5" ] ; then
2016-10-10 13:00:20 +02:00
echo " Usage is: ${ 0 } \"coverage\" \"<prepend CFLAGS>\" \"<makefile>\" \"<append CFLAGS>\" <math library to link to> "
2016-04-03 17:45:16 +02:00
echo " CC=gcc ${ 0 } \"coverage\" \" \" \"makefile\" \"-DUSE_LTM -DLTM_DESC -I../libtommath\" ../libtommath/libtommath.a "
exit -1
fi
2014-05-05 11:06:40 +02:00
if [ -z " $( echo $CC | grep "gcc" ) " ] ; then
echo "no gcc detected, early exit success"
exit 0
fi
# output version
bash printinfo.sh
2016-04-03 17:45:16 +02:00
bash build.sh " $1 " " $2 " " $3 COVERAGE=1 " " $4 -fprofile-arcs -ftest-coverage " " $5 -lgcov "
2014-05-05 11:06:40 +02:00
if [ -a testok.txt ] && [ -f testok.txt ] ; then
echo
else
2017-02-24 20:50:37 +01:00
echo
echo "Test failed"
exit 1
2014-05-05 11:06:40 +02:00
fi
2016-01-26 21:57:42 +01:00
./sizes
./constants
2017-04-23 22:04:39 +02:00
2017-05-02 00:01:30 +02:00
for i in $( for j in $( echo $( ./hashsum -h | tail -n +3) ) ; do echo $j ; done | sort) ; do echo -n " $i : " && ./hashsum -a $i testprof/test.key ; done > hashsum_tv.txt
2017-04-23 16:10:01 +02:00
difftroubles = $( diff -i -w -B hashsum_tv.txt notes/hashsum_tv.txt | grep '^<' ) || true
if [ -n " $difftroubles " ] ; then
echo "FAILURE: hashsum_tv.tx"
diff -i -w -B hashsum_tv.txt notes/hashsum_tv.txt
echo "hashsum failed" && rm -f testok.txt && exit 1
else
echo "hashsum okay"
fi
2016-01-26 21:57:42 +01:00
2016-04-03 17:45:16 +02:00
# if this was executed as './coverage.sh ...' create coverage locally
if [ [ " ${ 0 %% * } " = = " ./ ${ 0 ##*/ } " ] ] ; then
2017-02-24 20:50:37 +01:00
make lcov-single
2016-04-03 17:45:16 +02:00
else
2017-02-24 20:50:37 +01:00
cpp-coveralls -e 'demos/' -e 'testprof/' -e 'notes/' -e 'src/headers/'
2016-04-03 17:45:16 +02:00
fi
2014-05-05 11:06:40 +02:00
exit 0
# $Source$
# $Revision$
# $Date$